<template>
  <v-dialog v-model="show" attach="#app" max-width="1100">
    <v-card v-if="item">
      <v-card-title class="pl-4 pr-1 py-1 text-subtitle-1 primary white--text">
        {{ mode === "create" ? $t(`${i18nBase}.add`) : $t(`${i18nBase}.edit`) }}
        <v-spacer />
        <GDropDownMenu
          i18n="form.addElement"
          :available-elements="availableElements"
          small
          icon="add"
          btn-class="theme--dark"
        />
      </v-card-title>
      <v-card-text class="pt-0 px-4 overflow-y-auto" style="max-height: 74vh">
        <v-form ref="form" v-model="valid" @submit.prevent="submit">
          <slot
            :item="item"
            :update-available-elements="updateAvailableElements"
          />
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer />
        <v-btn color="error" text @click="close">
          {{ $t("form.cancel") }}
        </v-btn>
        <v-btn color="success" text :disabled="!valid" @click="submit">
          {{ mode === "create" ? $t("form.create") : $t("form.save") }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";

export default {
  name: "GAddEditDialog",
  components: { GDropDownMenu },
  props: {
    i18nBase: {
      type: String,
    },
    useWrapper: {
      type: Boolean,
    },
  },
  data() {
    return {
      valid: true,
      mode: "create",
      resolve: null,
      show: false,
      item: null,
      availableElements: [],
    };
  },
  methods: {
    updateAvailableElements(val) {
      this.$set(this, "availableElements", val);
    },
    create(item) {
      this.mode = "create";
      item = item ?? {};
      this.item = this.useWrapper ? { value: item } : item;
      this.show = true;
      this.$nextTick(() => {
        this.$refs.form.resetValidation();
      });
      return new Promise((resolve) => {
        this.resolve = resolve;
      });
    },
    edit(item) {
      this.mode = "edit";
      this.item = this.useWrapper ? { value: item } : item;
      this.show = true;
      this.$nextTick(() => {
        this.$refs.form.resetValidation();
      });
      return new Promise((resolve) => {
        this.resolve = resolve;
      });
    },
    submit() {
      if (this.$refs.form.validate()) {
        this.show = false;
        this.resolve(this.useWrapper ? this.item.value : this.item);
      }
    },
    close() {
      this.show = false;
      this.resolve = null;
    },
  },
};
</script>
